#include <vector>
#include <list>
#include <iostream>
#include <string>
#include <ctime>
#include <time.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>

using namespace std;
using std::string;

class Message
{

public:
Message(){ this->head = 1; this->body="hello"; };
~Message(){};

void setHead(int head){ this->head = head; };
int getHead(){ return this->head; };

void setBody(const string& body){ this->body = body; };
string getBody(){ return this->body; };

private:
        int head;
        string body;
};

string getNowTimeNs() {
	struct timespec ts;
	clock_gettime(CLOCK_REALTIME, &ts);
	struct tm t;
	char date_time[64];
	strftime(date_time, sizeof(date_time), "%Y-%m-%d %H:%M:%S", localtime_r(&ts.tv_sec, &t));
	string s = ", ";
	return (date_time + s + std::to_string(ts.tv_sec) + s + std::to_string(ts.tv_nsec));
}


int main(int argc, char **argv) {
	
	Message *msg = new Message();
	std::vector<Message *> *myvector = new vector<Message *>();
	myvector->reserve(65536);
	std::list<Message *> *mylist = new list<Message *>();



	std::cout << "start vector push_back():" << getNowTimeNs() << std::endl;
	for (int i = 0; i < 65536; ++i) {
		myvector->push_back(msg);	
	}
	std::cout << "end vector push_back():" << getNowTimeNs() << std::endl;


	std::cout << "start list push_back():" << getNowTimeNs() << std::endl;
	for (int i = 0; i < 65536; ++i) {
		mylist->push_back(msg);	
	}
	std::cout << "end list push_back():" << getNowTimeNs() << std::endl;


	std::cout << "------------------------------------------" << std::endl;


	std::cout << "start vector iterator:" << getNowTimeNs() << std::endl;
	for (std::vector<Message *>::iterator it = myvector->begin(); it != myvector->end(); ++it) {
		//std::cout << ", " << *it;
	}
	std::cout << "end vector iterator:" << getNowTimeNs() << std::endl;



	std::cout << "start list iterator:" << getNowTimeNs() << std::endl;
	for (std::list<Message *>::iterator lit = mylist->begin(); lit != mylist->end(); ++lit) {
		//std::cout << ", " << *lit;
	}
	std::cout << "end list iterator:" << getNowTimeNs() << std::endl;
	
	return 0;
}
